using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MVR.FileManagementSecure;
using Random2 = System.Random;
using Random = UnityEngine.Random;


namespace SPQR
{

    public class VDUIworks
    {
        VirtualDoll X;


        string[] tabs_p67 = new string[] { "Virtual Doll",   "Presets" };
        public Dictionary<string, bool> tabsBool_p67 = new Dictionary<string, bool>();
        public Dictionary<string, UIDynamicButton> tabsButtons_p67 = new Dictionary<string, UIDynamicButton>();
        public Dictionary<string, UIDynamicButton> uiButtons_p67 = new Dictionary<string, UIDynamicButton>();




        public VDUIworks(VirtualDoll script)
        {
            X = script;
        }



        public void InitUI_p67()
        {




            X.jstring_p67 = new JSONStorableString("instructions1", "");
            X.jstring2_p67 = new JSONStorableString("instructions2", "");



            bool showUI = false;




            // VirtualDoll
            X.enableFeatures_p67.Add("enable_virtualdoll", new JSONStorableBool("Enable Virtualdoll", false, X.dollworks_p67.EnableVirtualdoll));
            X.enableFeatures_p67.Add("enable_virtualdoll_line", new JSONStorableBool("Show VD Line", false));
            X.enableFeatures_p67.Add("enable_autorecalibrate", new JSONStorableBool("Auto-recalibrate", true));
            X.sliders_p67.Add("VDPreview", new JSONStorableFloat("Preview", 0f, 0f, 1f, true, false));
            X.sliders_p67.Add("VDMaxDistance", new JSONStorableFloat("Tracker Distance", 0.5f, 0.05f, 2f, false));
            X.sliders_p67.Add("VDMaxMovement", new JSONStorableFloat("Movement Distance", 0.25f, 0.05f, 2f, false));
            X.sliders_p67.Add("VDReset", new JSONStorableFloat("Reset on Distance", 10f, 0f, 10f, false));
            X.choosers_p67.Add("VDMode", new JSONStorableStringChooser("Mode", X.dollworks_p67.modes, "Ride", "VD Mode", X.dollworks_p67.callbackUpdateMode_p67));
            X.RegisterStringChooser(X.choosers_p67["VDMode"]);
            X.choosers_p67.Add("VDModeSticky", new JSONStorableStringChooser("Sticky", X.dollworks_p67.modesSticky, "None", "VD Sticky", X.dollworks_p67.callbackUpdateModeSticky_p67));
            X.RegisterStringChooser(X.choosers_p67["VDModeSticky"]);

            var a = new JSONStorableAction("Recalibrate", X.dollworks_p67.helpRecalibrate_p67);
            X.RegisterAction(a);

            foreach (var str in X.strings_p67)
            {
                X.strings_p67[str.Key].storeType = JSONStorableParam.StoreType.Full;
                X.RegisterString(X.strings_p67[str.Key]);
            }





            foreach (var enableitem in X.enableFeatures_p67)
            {
                enableitem.Value.storeType = JSONStorableParam.StoreType.Full;
                X.RegisterBool(enableitem.Value);
            }


            foreach (var slideritem in X.sliders_p67)
            {
                slideritem.Value.storeType = JSONStorableParam.StoreType.Full;
                X.RegisterFloat(slideritem.Value);
            }


            X.CreateTitle_p67("titlepluginname", "Virtual Doll", 40, false);

            foreach (var tab in tabs_p67)
            {
                tabsBool_p67[tab] = false;
                tabsButtons_p67[tab] = CreateTabButton_p67(tab, false);
                tabsButtons_p67[tab].button.onClick.AddListener(() =>
                {
                    TabsHideAll_p67();
                    TabShow_p67(tab);
                    foreach (var tab2 in tabs_p67)
                    {
                        tabsButtons_p67[tab2].buttonColor = X.colorworks_p67.GetColorMidPurple_p67();
                    }
                    tabsButtons_p67[tab].buttonColor = X.colorworks_p67.GetColorDeepPurple_p67();
                });

            }



        }




        public void TabsHideAll_p67()
        {
            tabsToggleVirtualdoll_p67(false);
            tabsTogglePresets_p67(false);
        }

      
        private void tabsToggleVirtualdoll_p67(bool show)
        {
            if (show)
            {
                X.CreateToggle(X.enableFeatures_p67["enable_virtualdoll"], true);
                X.CreateToggle(X.enableFeatures_p67["enable_virtualdoll_line"], true);
                X.CreateToggle(X.enableFeatures_p67["enable_autorecalibrate"], true);
                var s1 = X.CreateSlider(X.sliders_p67["VDPreview"], true);
                s1.quickButtonsEnabled = false;
                s1.defaultButtonEnabled = false;
                X.CreateSlider(X.sliders_p67["VDMaxDistance"], true);
                X.CreateSlider(X.sliders_p67["VDMaxMovement"], true);
                X.CreateSlider(X.sliders_p67["VDReset"], true);
                UIDynamicPopup p1 = X.CreateScrollablePopup(X.choosers_p67["VDMode"], true);
                UIDynamicPopup p2 = X.CreateScrollablePopup(X.choosers_p67["VDModeSticky"], true);

                X.buttons_p67["vd_button_select_atom"] = X.CreateButton("Select VD Controller", true);
                X.buttons_p67["vd_button_select_atom"].button.onClick.AddListener(X.dollworks_p67.helpSelectController_p67);

                X.buttons_p67["vd_button_recalibrate"] = X.CreateButton("Recalibrate", true);
                X.buttons_p67["vd_button_recalibrate"].button.onClick.AddListener(X.dollworks_p67.helpRecalibrate_p67);

            }
            else
            {
                if (X.enableFeatures_p67.ContainsKey("enable_virtualdoll")) X.RemoveToggle(X.enableFeatures_p67["enable_virtualdoll"]);
                if (X.enableFeatures_p67.ContainsKey("enable_virtualdoll_line")) X.RemoveToggle(X.enableFeatures_p67["enable_virtualdoll_line"]);
                if (X.enableFeatures_p67.ContainsKey("enable_autorecalibrate")) X.RemoveToggle(X.enableFeatures_p67["enable_autorecalibrate"]);
                if (X.sliders_p67.ContainsKey("VDPreview")) X.RemoveSlider(X.sliders_p67["VDPreview"]);
                if (X.sliders_p67.ContainsKey("VDMaxDistance")) X.RemoveSlider(X.sliders_p67["VDMaxDistance"]);
                if (X.sliders_p67.ContainsKey("VDMaxMovement")) X.RemoveSlider(X.sliders_p67["VDMaxMovement"]);
                if (X.sliders_p67.ContainsKey("VDReset")) X.RemoveSlider(X.sliders_p67["VDReset"]);
                if (X.choosers_p67.ContainsKey("VDMode")) X.RemovePopup(X.choosers_p67["VDMode"]);
                if (X.choosers_p67.ContainsKey("VDModeSticky")) X.RemovePopup(X.choosers_p67["VDModeSticky"]);

                if (X.buttons_p67.ContainsKey("vd_button_select_atom")) X.RemoveButton(X.buttons_p67["vd_button_select_atom"]);
                if (X.buttons_p67.ContainsKey("vd_button_recalibrate")) X.RemoveButton(X.buttons_p67["vd_button_recalibrate"]);
            }
        }


       
        private void tabsTogglePresets_p67(bool show)
        {

            if (show)
            {
                X.buttons_p67["load_preset"] = X.CreateButton("Load Preset", true);
                X.buttons_p67["load_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(X.SavePath_p67);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(X.SavePath_p67);
                    SuperController.singleton.GetMediaPathDialog(X.HandleLoadPreset_p67, X.SaveExtension_p67, X.SavePath_p67, false, true, false, null, false, shortcuts);
                });

                X.buttons_p67["save_preset"] = X.CreateButton("Save Preset", true);
                X.buttons_p67["save_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(X.SavePath_p67);
                    var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                    fileBrowserUI.SetTitle("Save Preset");
                    fileBrowserUI.fileRemovePrefix = null;
                    fileBrowserUI.hideExtension = true;
                    fileBrowserUI.keepOpen = false;
                    fileBrowserUI.canCancel = true;
                    fileBrowserUI.fileFormat = X.SaveExtension_p67;
                    fileBrowserUI.defaultPath = X.SavePath_p67;
                    fileBrowserUI.showDirs = true;
                    fileBrowserUI.showFiles = true;
                    fileBrowserUI.shortCuts = null;
                    fileBrowserUI.browseVarFilesAsDirectories = false;
                    fileBrowserUI.SetTextEntry(true);
                    fileBrowserUI.Show(X.HandleSavePreset_p67);
                    fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + X.SaveExtension_p67;
                    fileBrowserUI.ActivateFileNameField();

                });
            }
            else
            {
                if (X.buttons_p67.ContainsKey("save_preset"))
                    X.RemoveButton(X.buttons_p67["save_preset"]);
                if (X.buttons_p67.ContainsKey("load_preset"))
                    X.RemoveButton(X.buttons_p67["load_preset"]);
                // if (X.buttons_p67.ContainsKey("load_defaults"))
                //     RemoveButton(X.buttons_p67["load_defaults"]);
            }
        }
        
        private void TabShow_p67(string tab)
        {
            try
            {
                tabsBool_p67[tab] = true;
                switch (tab)
                {
                    case "Virtual Doll": tabsToggleVirtualdoll_p67(true); break;
                    case "Presets": tabsTogglePresets_p67(true); break;


                }
            }
            catch (Exception e)
            {
                //   SuperController.LogError("Exception caught: " + e);
            }


        }




        public UIDynamicButton CreateTabButton_p67(string label, bool rightSide = false)
        {
            UIDynamicButton uIDynamicButton = null;
            if (X.manager != null && X.manager.configurableButtonPrefab != null)
            {
                Transform transform = X.getUITransform_p67(rightSide);
                if (transform != null)
                {

                    uIDynamicButton = transform.GetComponent<UIDynamicButton>();
                    if (uIDynamicButton != null)
                    {
                        uIDynamicButton.label = label;
                        uIDynamicButton.buttonColor = X.colorworks_p67.GetColorMidPurple_p67();
                        uIDynamicButton.textColor = X.colorworks_p67.GetColorLight_p67();
                    }
                }
            }
            return uIDynamicButton;
        }

      
    }







}