﻿
using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MVR.FileManagementSecure;
using Random2 = System.Random;
using Random = UnityEngine.Random;

namespace SPQR
{
    public class VirtualDoll : MVRScript
    {


        public bool run;

        public bool aeternumSelected = false;

        public Atom PersonAtom;


        public VDColorworks colorworks_p67;
        public VDDollworks dollworks_p67;
        public VDUIworks uiworks_p67;
      

        public bool debugMode_p67 = false;
        public bool debugStopMode_p67 = false;
        public bool initblinkEnabled_p67 = false;


        public JSONStorableString jstring_p67;
        public JSONStorableString jstring2_p67;



        public float myClock_p67 = -1.0f;


        public string SavePath_p67 = "Saves\\PluginData\\VirtualDoll";
        public string SaveExtension_p67 = "json";
       

        public Dictionary<string, bool> flags_p67 = new Dictionary<string, bool>()
        {
        };

       
        /* other */

        public bool gameIsVR_p67;

        GameObject playerHands_p67;

        protected JSONStorableString myString_p67;


        Dictionary<string, float> clicks_p67 = new Dictionary<string, float>();
        private float downClickTime_p67;
        private float ClickDeltaTime_p67 = 1f;

        public Dictionary<string, JSONStorableBool> enableFeatures_p67 = new Dictionary<string, JSONStorableBool>();

        public Dictionary<string, JSONStorableString> strings_p67 = new Dictionary<string, JSONStorableString>();

        public Dictionary<string, UIDynamicButton> buttons_p67 = new Dictionary<string, UIDynamicButton>();

        public Dictionary<string, JSONStorableFloat> sliders_p67 = new Dictionary<string, JSONStorableFloat>();

        public Dictionary<string, JSONStorableStringChooser> choosers_p67 = new Dictionary<string, JSONStorableStringChooser>();

        public string scriptkey_p67;
        public string personId_p67;



        public static float Clamp_p67(float value, float min, float max)
        {
            return (value < min) ? min : (value > max) ? max : value;
        }
       
        public string AtomUidAddSuffix_p67(string s)
        {
            s += "-" + personId_p67;
            return s;
        }

        public override void Init()
        {

            PersonAtom = SPQRUtils.GetAtomById_p67(containingAtom.uid);
            personId_p67 = PersonAtom.uid;


            colorworks_p67 = new VDColorworks(this);
            dollworks_p67 = new VDDollworks(this);
            uiworks_p67 = new VDUIworks(this);
           

            gameIsVR_p67 = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);

            uiworks_p67.InitUI_p67();
    
            dollworks_p67.Init_p67();

            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;

        }

        void OnDestroy()
        {
            SuperController.singleton.onAtomUIDRenameHandlers -= OnAtomRename;
        }

        private void OnAtomRename(string oldid, string newid)
        {

            if (personId_p67 == oldid)
            {
                personId_p67 = newid;
                foreach (var atom in SuperController.singleton.GetAtoms())
                {
                    if (atom.uid.EndsWith("-" + oldid) && atom.uid.StartsWith("VirtualDoll"))
                    {
                        var newuid = atom.uid.Replace("-" + oldid, "-" + newid);
                        SuperController.singleton.RenameAtom(atom, newuid);
                    }
                }
            }


        }


        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            
            return jc;
        }

        void Start()
        {
           
            InvokeRepeating("UpdateSecond5s_p67", 1f, 5f);
            InvokeRepeating("UpdateSecond_p67", 1f, 1f);
            InvokeRepeating("UpdateConstant_p67", 1f, 1f / 30f);
            InvokeRepeating("UpdateConstant5_p67", 1f, 1f / 5f);

        }

        int second = 0;

        void UpdateSecond5s_p67()
        {
            if (IsDisabled_p67()) return;

        }
        void UpdateSecond_p67()
        {
            if (IsDisabled_p67()) return;

            try
            {
                second = ++second % 60;

                dollworks_p67.UpdateSecond_p67();

            }
            catch (Exception e)
            {
                SuperController.LogError("err:" + e);
            }
            //  eyeworks_p67.getHeadAngle_p67(); // temp

        }

        void UpdateConstant_p67()
        {
            if (IsDisabled_p67()) return;
            try
            {
              
                dollworks_p67.UpdateConstant_p67();
               
            } catch(Exception e)
            {
               // SuperController.LogError("error uc: " + e);
            }
        }


        void UpdateConstant5_p67()
        {
            if (IsDisabled_p67()) return;
            dollworks_p67.UpdateConstant5_p67();
        }

        public bool IsDisabled_p67()
        {
            if (SuperController.singleton.freezeAnimationToggle.isOn) return true;
            if (!enabledJSON.val) return true;
      
            return false;
        }

        void Update()
        {
            if (IsDisabled_p67()) return;
            dollworks_p67.Update_p67();
        }



      

        void FixedUpdate()
        {
            if (IsDisabled_p67()) return;
            try
            {
                dollworks_p67.FixedUpdate_p67();
              
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }



        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
           


        }




       

        IEnumerator Wait_p67(float seconds)
        {
            yield return new WaitForSeconds(seconds);
        }





        public void HandleLoadPreset_p67(string path)
        {
            if (path == null) return;
            var jc = (JSONClass)LoadJSON(path);
            base.RestoreFromJSON(jc);
        }

        public void HandleSavePreset_p67(string path)
        {
            //SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (path == null || path == "") return;
            if (!path.EndsWith("." + SaveExtension_p67))
            {
                path += "." + SaveExtension_p67;
            }
            var jc = GetJSON(true, true, true);
            SaveJSON(jc, path);
            SuperController.singleton.DoSaveScreenshot(path);
        }

        private void LoadFromJson_p67(JSONClass jsonClass)
        {
        }



        public IEnumerator CoroutineCreateAtom_p67(string type, string atomid)
        {
            yield return SuperController.singleton.AddAtomByType(type, atomid);
        }






        Dictionary<string, JSONStorableString> titles = new Dictionary<string, JSONStorableString>();

        public void CreateTitle_p67(string id, string text, int fontsize, bool right, int spacing)
        {
            CreateTitle_p67(id, text, fontsize, right);
            SPQRUtils.CreateSpacer_p67(this, spacing, right);
        }

        public void CreateTitle_p67(string id, string text, int fontsize, bool right)
        {
            if (!titles.ContainsKey(id))
                titles.Add(id, new JSONStorableString("title " + id, "\n<size=" + fontsize + "><b>" + text + "</b></size>"));
            UIDynamicTextField title1text = CreateTextField(titles[id], right);
            title1text.UItext.supportRichText = true;
            title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
            title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            title1text.height = 100f;
            title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

        public void L(string s)
        {
            SuperController.LogMessage(s);
        }
        public void E(string s)
        {
            SuperController.LogError(s);
        }
        public List<Transform> getRightUIElements_p67()
        {
            return rightUIElements;
        }
        public List<Transform> getLeftUIElements_p67()
        {
            return leftUIElements;
        }

        public Transform getUITransform_p67(bool rightSide)
        {
            return CreateUIElement(manager.configurableButtonPrefab.transform, rightSide);
        }

        public void PluginMessage_p67(string s)
        {
        }

    }







}

